]> git.ipfire.org Git - thirdparty/git.git/blame - git-pull.sh
GIT-VERSION-GEN: support non-standard $GIT_DIR path
[thirdparty/git.git] / git-pull.sh
CommitLineData
839a7a06
LT
1#!/bin/sh
2#
521003ff
JH
3# Copyright (c) 2005 Junio C Hamano
4#
5# Fetch one or more remote refs and merge it/them into the current HEAD.
6
d8abe148 7USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
806f36d4 8LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
533b7039 9SUBDIRECTORY_OK=Yes
8f321a39 10OPTIONS_SPEC=
ae2b0f15 11. git-sh-setup
a9f57868 12. git-sh-i18n
c98d1e41 13set_reflog_action "pull${1+ $*}"
035b5bf6 14require_work_tree_exists
533b7039 15cd_to_toplevel
b10ac50f 16
d38a30df
MM
17
18die_conflict () {
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
85af5f82 21 die "$(gettext "Pull is not possible because you have unmerged files.
d38a30df 22Please, fix them up in the work tree, and then use 'git add/rm <file>'
85af5f82 23as appropriate to mark resolution, or use 'git commit -a'.")"
d38a30df 24 else
85af5f82 25 die "$(gettext "Pull is not possible because you have unmerged files.")"
d38a30df
MM
26 fi
27}
28
29die_merge () {
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
85af5f82
ÆAB
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32Please, commit your changes before you can merge.")"
d38a30df 33 else
85af5f82 34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
d38a30df
MM
35 fi
36}
37
38test -z "$(git ls-files -u)" || die_conflict
39test -f "$GIT_DIR/MERGE_HEAD" && die_merge
d1014a17 40
13474835 41strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
7dce19d3 42log_arg= verbosity= progress= recurse_submodules=
85808300 43merge_args= edit=
cd67e4d4 44curr_branch=$(git symbolic-ref -q HEAD)
0d12e59f 45curr_branch_short="${curr_branch#refs/heads/}"
cd67e4d4 46rebase=$(git config --bool branch.$curr_branch_short.rebase)
6b37dff1
ÆAB
47if test -z "$rebase"
48then
49 rebase=$(git config --bool pull.rebase)
50fi
29609e68 51dry_run=
822f7c73 52while :
60fb5b2c
JH
53do
54 case "$1" in
7f87aff2 55 -q|--quiet)
c6576f91 56 verbosity="$verbosity -q" ;;
7f87aff2 57 -v|--verbose)
c6576f91 58 verbosity="$verbosity -v" ;;
9839018e
TRC
59 --progress)
60 progress=--progress ;;
bebd2fd7
JK
61 --no-progress)
62 progress=--no-progress ;;
d8abe148 63 -n|--no-stat|--no-summary)
a334e125 64 diffstat=--no-stat ;;
d8abe148 65 --stat|--summary)
a334e125 66 diffstat=--stat ;;
efb779f8
SG
67 --log|--no-log)
68 log_arg=$1 ;;
123ee3ca
JH
69 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
70 no_commit=--no-commit ;;
5072a323
LH
71 --c|--co|--com|--comm|--commi|--commit)
72 no_commit=--commit ;;
85808300
LT
73 -e|--edit)
74 edit=--edit ;;
75 --no-edit)
76 edit=--no-edit ;;
7d0c6887
JH
77 --sq|--squ|--squa|--squas|--squash)
78 squash=--squash ;;
5072a323
LH
79 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
80 squash=--no-squash ;;
81 --ff)
82 no_ff=--ff ;;
83 --no-ff)
84 no_ff=--no-ff ;;
13474835
BG
85 --ff-only)
86 ff_only=--ff-only ;;
60fb5b2c
JH
87 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
88 --strateg=*|--strategy=*|\
89 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
90 case "$#,$1" in
91 *,*=*)
8096fae7 92 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
60fb5b2c
JH
93 1,*)
94 usage ;;
95 *)
96 strategy="$2"
97 shift ;;
98 esac
99 strategy_args="${strategy_args}-s $strategy "
100 ;;
ee2c7955
AP
101 -X*)
102 case "$#,$1" in
103 1,-X)
104 usage ;;
105 *,-X)
14e5d40c 106 xx="-X $(git rev-parse --sq-quote "$2")"
ee2c7955
AP
107 shift ;;
108 *,*)
14e5d40c 109 xx=$(git rev-parse --sq-quote "$1") ;;
ee2c7955
AP
110 esac
111 merge_args="$merge_args$xx "
112 ;;
cd67e4d4
JS
113 -r|--r|--re|--reb|--reba|--rebas|--rebase)
114 rebase=true
115 ;;
116 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
117 rebase=false
118 ;;
7dce19d3
JL
119 --recurse-submodules)
120 recurse_submodules=--recurse-submodules
121 ;;
8f0700dd
JL
122 --recurse-submodules=*)
123 recurse_submodules="$1"
124 ;;
be254a0e
JL
125 --no-recurse-submodules)
126 recurse_submodules=--no-recurse-submodules
127 ;;
29609e68
JK
128 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
129 dry_run=--dry-run
130 ;;
87182b17 131 -h|--help-all)
93d69d86
JL
132 usage
133 ;;
822f7c73
DK
134 *)
135 # Pass thru anything that may be meant for fetch.
619e5a0e 136 break
60fb5b2c
JH
137 ;;
138 esac
139 shift
140done
141
441ed413
JH
142error_on_no_merge_candidates () {
143 exec >&2
144 for opt
145 do
146 case "$opt" in
147 -t|--t|--ta|--tag|--tags)
148 echo "Fetching tags only, you probably meant:"
149 echo " git fetch --tags"
150 exit 1
151 esac
152 done
153
995fc2f7
JK
154 if test true = "$rebase"
155 then
156 op_type=rebase
157 op_prep=against
158 else
159 op_type=merge
160 op_prep=with
161 fi
162
441ed413 163 curr_branch=${curr_branch#refs/heads/}
a6dbf881 164 upstream=$(git config "branch.$curr_branch.merge")
a8c9bef4 165 remote=$(git config "branch.$curr_branch.remote")
441ed413 166
a8c9bef4 167 if [ $# -gt 1 ]; then
995fc2f7
JK
168 if [ "$rebase" = true ]; then
169 printf "There is no candidate for rebasing against "
170 else
171 printf "There are no candidates for merging "
172 fi
173 echo "among the refs that you just fetched."
a8c9bef4
JK
174 echo "Generally this means that you provided a wildcard refspec which had no"
175 echo "matches on the remote end."
176 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
177 echo "You asked to pull from the remote '$1', but did not specify"
995fc2f7 178 echo "a branch. Because this is not the default configured remote"
a8c9bef4 179 echo "for your current branch, you must specify a branch on the command line."
15a147e6
MZ
180 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
181 . git-parse-remote
182 error_on_missing_default_upstream "pull" $op_type $op_prep \
3c02396a 183 "git pull <remote> <branch>"
a6dbf881 184 else
995fc2f7
JK
185 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
186 echo "from the remote, but no such ref was fetched."
61e6108d 187 fi
441ed413
JH
188 exit 1
189}
190
c85c7927 191test true = "$rebase" && {
19a7fcbf
JK
192 if ! git rev-parse -q --verify HEAD >/dev/null
193 then
194 # On an unborn branch
195 if test -f "$GIT_DIR/index"
196 then
85af5f82 197 die "$(gettext "updating an unborn branch with changes added to the index")"
19a7fcbf
JK
198 fi
199 else
92c62a3f 200 require_clean_work_tree "pull with rebase" "Please commit or stash them."
19a7fcbf 201 fi
d44e7126 202 oldremoteref= &&
e980765c 203 test -n "$curr_branch" &&
c85c7927 204 . git-parse-remote &&
d44e7126
SB
205 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
206 oldremoteref="$(git rev-parse -q --verify "$remoteref")" &&
207 for reflog in $(git rev-list -g $remoteref 2>/dev/null)
208 do
209 if test "$reflog" = "$(git merge-base $reflog $curr_branch)"
210 then
211 oldremoteref="$reflog"
212 break
213 fi
214 done
c85c7927 215}
2d179857 216orig_head=$(git rev-parse -q --verify HEAD)
7dce19d3 217git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
29609e68 218test -z "$dry_run" || exit 0
b10ac50f 219
2d179857 220curr_head=$(git rev-parse -q --verify HEAD)
b0ad11ea 221if test -n "$orig_head" && test "$curr_head" != "$orig_head"
b10ac50f
JH
222then
223 # The fetch involved updating the current branch.
224
225 # The working tree and the index file is still based on the
226 # $orig_head commit, but we are merging into $curr_head.
227 # First update the working tree to match $curr_head.
228
c2b1a95c 229 eval_gettextln "Warning: fetch updated the current branch head.
3320a973 230Warning: fast-forwarding your working tree from
c2b1a95c 231Warning: commit \$orig_head." >&2
7bd93c1c 232 git update-index -q --refresh
5be60078 233 git read-tree -u -m "$orig_head" "$curr_head" ||
9f35aaa9 234 die "$(eval_gettext "Cannot fast-forward your working tree.
8323124a 235After making sure that you saved anything precious from
9f35aaa9 236$ git diff \$orig_head
8323124a
JH
237output, run
238$ git reset --hard
9f35aaa9 239to recover.")"
8323124a 240
b10ac50f
JH
241fi
242
05dd8e2e
JH
243merge_head=$(sed -e '/ not-for-merge /d' \
244 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
245 tr '\012' ' ')
e0bfc81e
JH
246
247case "$merge_head" in
521003ff 248'')
4973aa22 249 error_on_no_merge_candidates "$@"
521003ff 250 ;;
60fb5b2c 251?*' '?*)
d09e79cb
LT
252 if test -z "$orig_head"
253 then
85af5f82 254 die "$(gettext "Cannot merge multiple branches into empty head")"
d09e79cb 255 fi
51b2ead0
JS
256 if test true = "$rebase"
257 then
85af5f82 258 die "$(gettext "Cannot rebase onto multiple branches")"
51b2ead0 259 fi
60fb5b2c
JH
260 ;;
261esac
262
d09e79cb
LT
263if test -z "$orig_head"
264then
b0ad11ea 265 git update-ref -m "initial pull" HEAD $merge_head "$curr_head" &&
4b3ffe51 266 git read-tree -m -u HEAD || exit 1
d09e79cb
LT
267 exit
268fi
269
cf65426d
EN
270if test true = "$rebase"
271then
272 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
273 if test "$oldremoteref" = "$o"
274 then
275 unset oldremoteref
276 fi
277fi
278
efb779f8 279merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
14e5d40c
JH
280case "$rebase" in
281true)
282 eval="git-rebase $diffstat $strategy_args $merge_args"
283 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
284 ;;
285*)
85808300 286 eval="git-merge $diffstat $no_commit $edit $squash $no_ff $ff_only"
bebd2fd7
JK
287 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
288 eval="$eval \"\$merge_name\" HEAD $merge_head"
14e5d40c
JH
289 ;;
290esac
291eval "exec $eval"